		/* Calcul du signe des determinants 2x2 */
		/* avec    l'arithmetique    redondante */
		/* Sylvain Pion              Juillet 95 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "arith.h"

int AR_det2 (double ad, double bd, double cd, double dd)
{
    NOMBRE *det;
    int signe;

    det = AR_sub( AR_mul (AR_dbl (&ad), AR_dbl (&dd)),
		  AR_mul (AR_dbl (&bd), AR_dbl (&cd)));

    signe = get_sign(det);
    AR_free_rec(det);
    return signe;
}
