
extern double LNP2[],LNP2x3[],LNt[];
extern int LNret[];

typedef double integer;
class Point2d;
class Point3d;
class Point4d;
class Plane;
class WPoint2d;
class WLPoint2d;
class Incircle3dHyperPlane;
class WPoint3d;
class WLPoint3d;
class WeightedIncircle3dHyperPlane;
class LongHomogPoint3d;
class LNextended64x0;
class LNextended221x1;
class LNextended220x2;
class LNextended221x3;
class LNextended165x4;
class LNextended274x5;
class LNextended65x6;
class LNextended222x7;
class LNextended221x8;
class LNextended222x9;
class LNextended165x10;
class LNextended275x11;
class LNextended163x12;
class LNextended162x13;
class LNextended163x14;
class LNextended162x15;


class Point2d{ public:
integer x;
integer y;
Point2d(){};
Point2d(const integer, const integer);
};

class Point3d{ public:
integer x;
integer y;
integer z;
Point3d(){};
Point3d(const integer, const integer, const integer);
};

class Point4d{ public:
integer x;
integer y;
integer z;
integer w;
Point4d(){};
Point4d(const integer, const integer, const integer, const integer);
};

class Plane{ public:
integer a;
integer b;
integer c;
integer d;
Plane(){};
Plane(const integer, const integer, const integer, const integer);
};

class WPoint2d{ public:
integer x;
integer y;
integer w;
WPoint2d(){};
};
class LNextended64x0 {public: double v0,v1,v2;
LNextended64x0(){};
};

class WLPoint2d{ public:
integer x;
integer y;
LNextended64x0 z;
WLPoint2d(){};
WLPoint2d(const integer, const integer, const integer);
};
class LNextended221x1 {public: double v0,v1,v2,v3,v4,v5,v6,v7,v8,v9;
LNextended221x1(){};
};
class LNextended220x2 {public: double v0,v1,v2,v3,v4,v5,v6,v7,v8,v9;
LNextended220x2(){};
};
class LNextended221x3 {public: double v0,v1,v2,v3,v4,v5,v6,v7,v8,v9;
LNextended221x3(){};
};
class LNextended165x4 {public: double v0,v1,v2,v3,v4,v5,v6,v7;
LNextended165x4(){};
};
class LNextended274x5 {public: double v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11;
LNextended274x5(){};
};

class Incircle3dHyperPlane{ public:
LNextended221x1 a;
LNextended220x2 b;
LNextended221x3 c;
LNextended165x4 d;
LNextended274x5 e;
Incircle3dHyperPlane(){};
Incircle3dHyperPlane(const Point3d&, const Point3d&, const Point3d&, const Point3d&);
};

class WPoint3d{ public:
integer x;
integer y;
integer z;
integer w;
WPoint3d(){};
};
class LNextended65x6 {public: double v0,v1,v2;
LNextended65x6(){};
};

class WLPoint3d{ public:
integer x;
integer y;
integer z;
LNextended65x6 w;
WLPoint3d(){};
WLPoint3d(const integer, const integer, const integer, const integer);
};
class LNextended222x7 {public: double v0,v1,v2,v3,v4,v5,v6,v7,v8,v9;
LNextended222x7(){};
};
class LNextended221x8 {public: double v0,v1,v2,v3,v4,v5,v6,v7,v8,v9;
LNextended221x8(){};
};
class LNextended222x9 {public: double v0,v1,v2,v3,v4,v5,v6,v7,v8,v9;
LNextended222x9(){};
};
class LNextended165x10 {public: double v0,v1,v2,v3,v4,v5,v6,v7;
LNextended165x10(){};
};
class LNextended275x11 {public: double v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11;
LNextended275x11(){};
};

class WeightedIncircle3dHyperPlane{ public:
LNextended222x7 a;
LNextended221x8 b;
LNextended222x9 c;
LNextended165x10 d;
LNextended275x11 e;
WeightedIncircle3dHyperPlane(){};
WeightedIncircle3dHyperPlane(const WPoint3d&, const WPoint3d&, const WPoint3d&, const WPoint3d&);
};
class LNextended163x12 {public: double v0,v1,v2,v3,v4,v5,v6,v7;
LNextended163x12(){};
};
class LNextended162x13 {public: double v0,v1,v2,v3,v4,v5,v6,v7;
LNextended162x13(){};
};
class LNextended163x14 {public: double v0,v1,v2,v3,v4,v5,v6,v7;
LNextended163x14(){};
};
class LNextended162x15 {public: double v0,v1,v2,v3,v4,v5,v6,v7;
LNextended162x15(){};
};

class LongHomogPoint3d{ public:
LNextended163x12 x;
LNextended162x13 y;
LNextended163x14 z;
LNextended162x15 w;
LongHomogPoint3d(){};
LongHomogPoint3d(const Plane&, const Plane&, const Plane&);
};

integer orient2d(const Point2d&, const Point2d&, const Point2d&);
int LN_det2x2(double, double, double, double);
integer horient2d(const Point2d&, const Point2d&);
integer orient3d(const Point3d&, const Point3d&, const Point3d&, const Point3d&);
int LN_det3x3(double, double, double, double, double, double, double, double,double);
integer horient3d(const Point3d&, const Point3d&, const Point3d&);
integer incircle2d(const Point2d&, const Point2d&, const Point2d&, const Point2d&);
integer wincircle2d(const WPoint2d&, const WPoint2d&, const WPoint2d&, const WPoint2d&);
integer wincircle2d(const WLPoint2d&, const WLPoint2d&, const WLPoint2d&, const WLPoint2d&);
integer orient4d(const Point4d&, const Point4d&, const Point4d&, const Point4d&, const Point4d&);
integer horient4d(const Point4d&, const Point4d&, const Point4d&, const Point4d&);
integer incircle3d(const Point3d&, const Point3d&, const Point3d&, const Point3d&, const Point3d&);
integer incircle3dbeyond(const Point3d&, const Incircle3dHyperPlane&);
integer wincircle3d(const WPoint3d&, const WPoint3d&, const WPoint3d&, const WPoint3d&, const WPoint3d&);
integer wincircle3d(const WLPoint3d&, const WLPoint3d&, const WLPoint3d&, const WLPoint3d&, const WLPoint3d&);
integer weightedincircle3dbeyond(const WPoint3d&, const WeightedIncircle3dHyperPlane&);
integer dot(const LongHomogPoint3d&, const Plane&);
integer LongHomogOrient3d(const LongHomogPoint3d&, const LongHomogPoint3d&, const LongHomogPoint3d&, const LongHomogPoint3d&);
